/* ALL RIGHTS RESERVED  2005 -
	Polaris8920, AbyssDragon, ACWraith, BYOND, and DanTom.

This is demo/library. You are free to include any of its contents
in your projects. Its contents are not for usage in your own library/
demo unless credit is given where credit is due. You may not claim it
as your own or imply it as your own in any way. If you do include it
in you own project, please give credit to Polaris8920 where credit
for this project is due. Credit is not due, if you use this as an
idea for your system, but if you use this and modify it, credit would
still greatly be appreciated.

Thanks to libraries made by these people that could make this compiled
version of their coding possible.
-AbyssDragon for his SortProcs library.
-ACWraith for his ListHelp library.

    ~ Polaris8920 (polaris8920@hotmail.com & polaris8920@gmail.com)

 - Best viewed with tab size 4.



************************HELP AND EXPLINATIONS************************
//*************************************
//****Full procedure and datum list****
//*************************************
proc
	array()
array
	var/list/value[0]
	New()
	proc
		get(start = "null", end = "null")
		to_text(separator = "")
		to_num()
		mean()
		median()
		mode()
		number_of_occurances(Elem, index = 1, end = 0)
		Set()
		swap(loc1, loc2)
		add()
		subtract()
		reverse()
		refresh()
		replace(search, replace)
		limit_all_occurances(Limit = 1, Fromback = 1)
		limit_occurances_of(Elem, Limit = 1, Fromback = 1)
		Compare(item1, item2)
		bubble_sort()
		insertion_sort()
		quick_sort(low = 1, high = -1)
		shell_sort()
	associative
		proc
			get_value(index)
			associations()
			set_value(index, new_value)
		add(index, add_value)
		subtract(index)
		refresh()
		bubble_sort()
		Set(_list)

number
	var/value = 0
	New(_num)
	proc
		get()
		reciprocal()
		Set(_number)
		add()
		subtract()
		multiply(number = 1)
		divide(number = 1)
		exponential(power = 1)
		factorial()
		floor()
		ceiling()
		Round()
		fahrenheit_to_celsius()
		celsius_to_fahrenheit()
	fraction
		var
			denominator = 1
			numerator = 1
		New(_n, _d)
		get()
		reciprocal()
		to_percent(text = 1)
		to_decimal()
		Set(_n, _d)
		add(_n, _d)
		subtract(_n, _d)
		multiply(_n, _d)
		divide(_n, _d)
		proc
			lowest_terms()

string
	var
		value
		list/words[0]
	New(_string)
	proc
		get()
		to_list(seperator = " ", case_sens = 0)
		starts_with(find = "")
		ends_with(find = "")
		copy_text(start = 1, end = 0)
		Set(_string)
		add()
		replace_text(search = "", replace = "", case_sens = 0)
		reverse()

//**************
//****Arrays****
//**************
proc
	array()
		Returns a new /array datum with the values stated in the arguments
		of the procedure.

array
	var/list/value[0]
		This is the list variable that holds the array's values.
	New()
		New() is used to have quick access to adding contents to the
		array. Anything stated as an argument in New(), will be added
		to the array's contents.
	proc
		//***********************
		//****Returning procs****
		//***********************
		get(start = "null", end = "null")
			This is based off the procedure list.Copy(). If you call it
			with no arguments, it will return the array's values. When
			called with a start but no end, it will return a copy of the
			array's values from start to the end of the value list. If
			get() is called with a start and an end, then the procedure
			will return a copy of the array's values, from the start
			variable, to the end variable.
		to_text(separator = "")
			This returns a text string of all of the array's values,
			separated by the separator arguement.
		to_num()
			This returns a number equal to all of the numerical values in
			the array added together.
		mean()
			This is the mean of all the numerical values in the array.
		median()
			This is the middle value, in an organized set of the array's
			values.
		mode()
			This is the most frequently occuring value in the array's
			values. It will return the value. To find the number of times
			that value occurs, use array.number_of_occurances().
		number_of_occurances(Elem, index = 1, end = 0)
			//**ACWraith's**
			This returns the number of times a value occurs in the array's
			values.
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set()
			This resets the array's values, and takes the arguements
			stated in the called procedure, and adds them to the new
			values. Returns the new array's values.
		swap(loc1, loc2)
			This swaps two values in the array. Call it like you would
			list.Swap() Returns the new array's values.
		add()
			This adds all of values stated in the arguements of the
			procedure to the array. Returns the new array's values.
		subtract()
			This removes all of values stated in the arguements of the
			procedure from the array. Returns the new array's values.
		reverse()
			This procedure reverses the values in the array. Returns the
			new array's values.
		refresh()
			Once called, this searchs the list for any null entries and
			removes them. Returns the new array's values.
		replace(search, replace)
			This replaces the all instances of seach with replace in the
			array. Returns the new array's values.
		limit_all_occurances(Limit = 1, Fromback = 1)
			This limits all of the occurances found in the array to the
			Limit variable. Fromback states if the procedure will remove
			the values from the back or front. Returns the new array's
			values.
		limit_occurances_of(Elem, Limit = 1, Fromback = 1)
			//**ACWraith's**
			This limits the occurances of Elem found in the array to the
			Limit variable. Fromback states if the procedure will remove
			the values from the back or front. Returns the new array's
			values.
		//*****************************
		//********Sorting Procs********
		//*****************************
		//All sorting procedures made by AbyssDragon.
		Compare(item1, item2)
			This compares two values. If the values are numerical, it
			will return the lower. If the values are text, it will return
			them in alphabetical order.
		bubble_sort()
			This is a standard bubble sort procedure. Returns the new
			array's values.
		insertion_sort()
			This is a standard insertion sort procedure. Returns the new
			array's values.
		quick_sort(low = 1, high = -1)
			This is a standard quick sort procedure. Returns the new
			array's values.
		shell_sort()
			This is a standard shell sort procedure. Returns the new
			array's values.
	associative
		//***********************
		//****Returning procs****
		//***********************
		proc
			get_value(index)
				This is used to get the value in the array. Returns the
				value of value[index].
			associations()
				This returns all of the associations in the array. If the
				array had a list of "A"=1, "B"=2; the associations would
				be "A" and "B".
		//*****************************
		//****Value changing procs*****
		//*****************************
		proc
			set_value(index, new_value)
		add(index, add_value)
			Adds index=add_value to the array.
		subtract(index)
			Removes the index and value of index from the array.
		refresh()
			Loops through the list. If it finds any entries with the value
			of null, it removes them.
		bubble_sort()
			This is an associative bubble sort, which sorts the array
			based on the fact that it is associative.
		Set(_list)
			If _list is a list, this sets the array to that list.


//***************
//****Numbers****
//***************
number
	var/value = 0
		The numerical value of the /number datum.
	New(_num)
		If _num is a number, then the value of the datum becomes _num.
	proc
		//***********************
		//****Returning procs****
		//***********************
		get()
			This returns the datum's numerical value.
		reciprocal()
			This returns the reciprocal of the number. By default,
			1/the numerical value of the datum.
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set(_number)
			If _number is a number, then the value of the datum becomes
			_number. Returns the datum's numerical value.
		add()
			For all of the numerical values stated in the arguements of
			the procedure, the numerical value of the datum is increased
			by that value. Returns the datum's numerical value.
		subtract()
			For all of the numerical values stated in the arguements of
			the procedure, the numerical value of the datum is decreased
			by that value. Returns the datum's numerical value.
		multiply(number = 1)
			If number is a number, the numerical value of the datum is
			multiplied by number. Returns the datum's numerical value.
		divide(number = 1)
			If number is a number, the numerical value of the datum is
			divided by number. Returns the datum's numerical value.
		exponential(power = 1)
			If power is a number, the numerical value is raised to the
			power of the numerical value of the power variable. Returns
			the datum's numerical value.
		factorial()
			This changes the numerical value of the datum, by its
			factorial. Returns the datum's numerical value.
		floor()
			This floors the numerical value of the datum. Returns the
			datum's numerical value.
		ceiling()
			This sets the numerical value of the datum to its ceiling.
			Returns the datum's numerical value.
		Round()
			This rounds the numerical value of the datum to the closest
			whole number. If you input something with a decimal value of
			less the 0.5, then it will floor the number. If you input
			something with a decimal value of 0.5 or greater, then the
			value of the datum will be set the ceiling of the number.
			Returns the datum's numerical value.
		fahrenheit_to_celsius()
			This changes the numerical value of the datum from degrees
			fahrenheit to celsius assuming the value of the datum is
			in fahrenheit, and its value is a temperature. Returns the
			datum's numerical value.
		celsius_to_fahrenheit()
			This changes the numerical value of the datum from degrees
			celsius to fahrenheit assuming the value of the datum is
			in celsius, and its value is a temperature. Returns the
			datum's numerical value.
	fraction
		var
			denominator = 1
				This is the denominator value of the fraction.
			numerator = 1
				This is the numerator value of the fraction.
		New(_n, _d)
			If _n is a number, the datum's numerator is set to _n. If _d
			is a number, the datum's denominator is set to _d.
		//***********************
		//****Returning procs****
		//***********************
		get()
			This returns a list of numerator and denominator.
		reciprocal()
			This returns the reciprocal of the datum's fraction. By
			default, 1/the decimal value of the datum's fraction.
		to_percent(text = 1)
			This returns the percentage formed by the datum's fraction.
		to_decimal()
			This returns the text string decimal formed by the datum's
			fraction.
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set(_n, _d)
			If _n is a number, the datum's numerator is set to _n. If _d
			is a number, the datum's denominator is set to _d. Returns
			the datum's fraction.
		add(_n, _d)
			If _n is a number, the datum's numerator is increased by _n.
			If _d is a number, the datum's denominator is increased by _d.
			Returns the datum's fraction.
		subtract(_n, _d)
			If _n is a number, the datum's numerator is decreased by _n.
			If _d is a number, the datum's denominator is decreased by _d.
			Returns the datum's fraction.
		multiply(_n, _d)
			This multiplys the datum's fraction by the fraction formed by
			_n over _d. Returns the datum's fraction.
		divide(_n, _d)
			This divides the datum's fraction by the fraction former by _n
			over _d. Returns the datum's fraction.
		proc
			lowest_terms()
				This sets the datum's fraction to the lowest terms that
				can be formed using that fraction. Returns the datum's
				fraction.


//***************
//****Strings****
//***************
string
	var
		value
			The text string value of the datum.
		list/words[0]
			The list of words in the datum. By default, the datum's text
			string seperated by spaces.
	New(_string)
		If _string is a text string, the value of the datum is set to
		_string.
	proc
		//***********************
		//****Returning procs****
		//***********************
		get()
			This returns the text string of datum's value.
		to_list(seperator = " ", case_sens = 0)
			This returns a list of words seperated by seperator. Call the
			procedure with case_sens to 1, to seperate the string case
			sensitivly.
		starts_with(find = "")
			Returns 1, if the datum's string starts with find.
		ends_with(find = "")
			Returns 1, if the datum's string ends with find.
		copy_text(start = 1, end = 0)
			Returns a text string of the copied text from start to end. If
			end equals zero, then end is set to the end of the string.
			Call like you would normal copytext().
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set(_string)
			If _string is a text string, the value of the datum is set to
			_string. Returns the datum's text string.
		add()
			For every part in the procedures arguements, if the part is a
			text string, add it to the datum's text string.
		replace_text(search = "", replace = "", case_sens = 0)
			This replaces all of the instances in the datum's text string
			that equal search with replace. Call the procedure with
			case_sens = 1 to use case sensitivity. Returns the datum's
			text string.
		reverse()
			This reverses the characters in the datum's text string.
			Returns the datum's text string.
*/