proc
	array()
		var/array/dot = new
		for(var/part in args) dot.add(part)
		. = dot
	ListToText(list/list)
		var/array/a = new(list)
		a.to_text()
		return a.get()
	QuickSort(list/list, low = 1, high = -1)
		var/array/a = new(list)
		a.quick_sort(low, high)
		return a.get()

array
	var/list/value[0]
	New(_list)
		if(!istype(src,/array/associative))
			for(var/part in args)
				add(part)
		else
			if(_list && istype(_list,/list)) value = _list
			else
				_list = list()
		..()
	proc
		//***********************
		//****Returning procs****
		//***********************
		get(start = "null", end = "null")
			if(start == "null" && end == "null") return value
			else if(start != "null" && end == "null" && isnum(start))
				return value.Copy(start,start+1)
			else if(start!="null"&&end!="null"&&isnum(start)&&isnum(end))
				return value.Copy(start,end)
		to_text(separator = "")
			if(!length(value)) return .
			if(length(value) < 2) return value[1]
			. = "[value[1]]"
			for(var/count = 2 to length(value))
				. += "[separator][value[count]]"
		to_num()
			if(!length(value)) return .
			. = 0
			for(var/part in value) if(isnum(part)) . += part
		mean()
			. = to_num()/length(value)
		median()
			var/array/dot = new(value)
			dot.quick_sort()
			. = dot.get()
			if(!(length(.)%2))
				return .[length(.)/2]+.[length(.)/2+1]+1
			else
				return .[length(.)/2+0.5]
		mode()
			if(!length(value)) return .
			var/max_mode = 0
			. = null
			for(var/part in value)
				var/num = number_of_occurances(part)
				if(num >= max_mode)
					max_mode = num
					if(. && istype(.,/list)) . += part
					else if(.&&!istype(.,/list)) . = list(.,part)
					else . = part
			if(istype(.,/list))
				var/array/returner = new
				returner.value = .
				returner.limit_all_occurances()
				. = returner.get()
				if(length(.) == 1) . = .[1]
		number_of_occurances(Elem, index = 1, end = 0)
			//**ACWraith's**
			if(index > length(value)) return 0
			if((end > 0) && (index > end)) return 0
			. = 0
			if(index < 1) index = 1
			if((end <= 0) || (end > (length(value) + 1)))
				end = length(value) + 1
			while(index < end)
				if(Elem == value[index]) . += 1
				index++
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set()
			value = new/list
			for(var/part in args) add(part)
		swap(loc1, loc2)
			value.Swap(loc1, loc2)
			return get()
		add()
			for(var/part in args) value += part
			return get()
		subtract()
			for(var/part in args) value -= part
			return get()
		reverse()
			if(!length(value)) return .
			for(var/count=1 to round(length(value)/2))
				swap(count,length(value)-(count-1))
			return get()
		refresh()
			if(!length(value)) return .
			for(var/part in value) if(isnull(part)) subtract(part)
			return get()
		replace(search, replace)
			if(!length(value) || !search) return .
			for(var/count = 1 to length(value))
				if(value[count] == search)
					value.Cut(count,count+1)
					value.Insert(count,replace)
			return get()
		limit_all_occurances(Limit = 1, Fromback = 1)
			for(var/part in value)
				limit_occurances_of(part, Limit, Fromback)
			return get()
		limit_occurances_of(Elem, Limit = 1, Fromback = 1)
			//**ACWraith's**
			if(isnull(value)) return 0
			if(!(Elem in value)) return 0
			if(Limit < 1)
				while(Elem in value) subtract(Elem)
				return 0
			var/elemOccurances = number_of_occurances(Elem)
			if(elemOccurances <= Limit) return 0
			if(Fromback)
				var/index = length(value)
				while(elemOccurances > Limit)
					if(value[index] == Elem)
						value.Cut(index,index+1)
						elemOccurances--
					index--
			else
				while(elemOccurances > Limit)
					subtract(Elem)
					elemOccurances--
			return get()
		//*****************************
		//********Sorting Procs********
		//*****************************
		//All sorting procedures made by AbyssDragon.
		Compare(item1, item2)
			if(isnum(item1) && isnum(item2))
				return item2<item1?-1 : (item1==item2?0:1)
			else return sortText("[item1]", "[item2]")
		bubble_sort()
			for(var/i = length(value); i >= 1; i--)
				for(var/j = 1; j < i; j++)
					if(Compare(value[j], value[j+1]) == -1)
						swap(j, j+1)
		insertion_sort()
			for(var/j in 2 to length(value))
				var
					key = value[j]
					i = j-1
				while(i>0 && Compare(value[i], key) == -1)
					value[i+1] = value[i]
					i--
				value[i+1] = key
		quick_sort(low = 1, high = -1)
			if(high == -1) high = length(value)
			if(low >= high) return
			var/pivot = quick_sort_partition(low, high)
			quick_sort(low, pivot-1)
			quick_sort(pivot+1, high)
		quick_sort_partition(low, high)
			var
				x = value[high]
				i = low -1
			for(var/j in low to high -1)
				if(Compare(value[j], x) == 1)
					i++
					swap(i, j)
			swap(i+1, high)
			return i + 1
		shell_sort()
			var/h=1
			while(h <= length(value))
				h = 3*h + 1
			while(h > 1)
				h = round(h/3)
				for(var/i = h + 1; i <= length(value); i++)
					var
						v = value[i]
						j = i
					while ((j>h) && Compare(value[j-h], v) == -1)
						value[j] = value[j-h]
						j -= h
					value[j] = v
	associative
		//***********************
		//****Returning procs****
		//***********************
		proc
			get_value(index)
				if(!istext(index)) return .
				. = value["[index]"]
			associations()
				. = new/list
				for(var/count = 1 to length(value))
					. += value[count]
		//*****************************
		//****Value changing procs*****
		//*****************************
		proc
			set_value(index, new_value)
				if(!istext(index)) return .
				value["[index]"] = new_value
				return get()
		add(index, add_value)
			value += list(index=value)
			return get()
		subtract(index)
			value["[index]"] = null
			refresh()
			return get()
		refresh()
			if(!length(value)) return .
			for(var/count = 1 to length(value))
				var
					Index = value[count]
					Value = value[Index]
				if(isnull(Value)) value -= Index
			return get()
		bubble_sort()
			for(var/x = 1,x <= length(value),x++)
				for(var/remain = length(value), remain > 1,remain--)
					var
						comp_a = value[remain-1]
						comp_b = value[remain]
					if(Compare(value[comp_a],value[comp_b]) == -1)
						swap(remain-1,remain)
		Set(_list)
			if(_list && istype(_list,/list)) value = _list