proc
	Add()
		var/number/n = new()
		for(var/part in args)n.add(part)
		return n.get()
	Floor(num)
		var/number/n = new(num)
		return n.floor()
	Ceiling(num)
		var/number/n = new(num)
		return n.ceiling()
	Round(num)
		var/number/n = new(num)
		return n.Round()

number
	var/value = 0
	New(_num)
		if(_num && isnum(_num)) value = _num
		..()
	proc
		//***********************
		//****Returning procs****
		//***********************
		get()
			return value
		reciprocal()
			. = 1/value
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set(_number)
			if(isnum(_number)) value = _number
		add()
			for(var/part in args) if(isnum(part)) value += part
			return get()
		subtract()
			for(var/part in args) if(isnum(part)) value -= part
			return get()
		multiply(number = 1)
			if(isnum(number)) value *= number
			return get()
		divide(number = 1)
			if(isnum(number)) value /= number
			return get()
		exponential(power = 1)
			if(isnum(power)) value ^= power
			return get()
		factorial()
			if(!isnum(value)) return .
			var/count = value-1
			while(count)
				value *= count
				count--
			return get()
		floor()
			var
				X = value%1
				Z = round(value)
			if(X<5) value=Z
			else value=Z+1
			return get()
		ceiling()
			var/old_value = value
			floor()
			if(old_value != value)
				value++
			return get()
		Round()
			var
				number
					old_value = new(value)
					decimal = new(value)
			if(decimal.subtract(old_value.floor()) < 0.5) floor()
			else ceiling()
			return get()
		fahrenheit_to_celsius()
			var/number/dot = new(1.8)
			. = (value-32)*dot.reciprocal()
			value = .
		celsius_to_fahrenheit()
			. = (value*1.8)+32
			value = .
	fraction
		var
			denominator = 1
			numerator = 1
		New(_n, _d)
			if(isnum(_d)) denominator = _d
			if(isnum(_n)) numerator = _n
			..()
		//***********************
		//****Returning procs****
		//***********************
		get()
			return list(numerator, denominator)
		reciprocal()
			. = 1/to_decimal()
		proc
			to_percent(text = 1)
				. = (numerator/denominator)*100
				if(text) . = "[.]%"
			to_decimal()
				. = numerator/denominator
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set(_n, _d)
			if(isnum(_n)) numerator = _n
			if(isnum(_d)) denominator = _d
			return get()
		add(_n, _d)
			numerator = (numerator*_d)+(_n*denominator)
			denominator = denominator*_d
			return get()
		subtract(_n, _d)
			numerator = (numerator*_d)-(_n*denominator)
			denominator = denominator*_d
			return get()
		multiply(_n, _d)
			numerator *= _n
			denominator *= _d
			return get()
		divide(_n, _d)
			numerator *= _d
			denominator *= _n
			return get()
		proc
			lowest_terms()
				var/max_count = 1
				for(var/count = 2 to min(numerator, denominator))
					if(!(numerator%count) && !(denominator%count))
						max_count = max(max_count, count)
				numerator /= max_count
				denominator /= max_count
				return get()