proc
	ToList(text, seperator = " ", case_sens = 0)
		var
			string/s = new(text)
			array/a = s.to_list(seperator, case_sens)
		return a.get()
	StartsWith(text, find)
		var/string/s = new(text)
		return s.starts_with(find)
	EndsWith(text, find)
		var/string/s = new(text)
		return s.ends_with(find)
	ReplaceText(text, search, replace, case_sens = 0)
		var/string/s = new(text)
		return s.replace_text(search, replace, case_sens)

string
	var
		value
		list/words[0]
	New(_string)
		if(_string && istext(_string))
			value = _string
			words = to_list()
		..()
	proc
		//***********************
		//****Returning procs****
		//***********************
		get()
			return value
		to_list(seperator = " ", case_sens = 0)
			var
				new_value = value
				array/returner = new
			var/find
			if(case_sens) find = findText("[new_value]","[seperator]")
			else find = findtext("[new_value]","[seperator]")
			while(find)
				returner.add(copytext(new_value,1,find))
				new_value = copytext(new_value,find+length(seperator))
				if(case_sens) find = findText("[new_value]","[seperator]")
				else find = findtext("[new_value]","[seperator]")
			returner.add(new_value)
			returner.refresh()
			return returner
		starts_with(find = "")
			if(!istext(find)) return 0
			if(findText(value,find) == 1) . = 1
		ends_with(find = "")
			if(!istext(find)) return 0
			if(findText(value,find,length(value)-length(find))) . = 1
		copy_text(start = 1, end = 0)
			if(!isnum(start) || !isnum(end)) return .
			. = ""
			if(!end) end = length(value)+1
			while(start < end && start <= length(value))
				. += ascii2text(text2ascii(value,start))
				start++
		//*****************************
		//****Value changing procs*****
		//*****************************
		Set(_string)
			if(istext(_string)) value = _string
		add()
			for(var/part in args) if(istext(part)) value += "[part]"
		replace_text(search = "", replace = "", case_sens = 0)
			if(!istext(search) || !istext(replace)) return 0
			var/array
				dot = to_list(search, case_sens)
				back = array()
			for(var/part in dot.get()) back.add(part)
			back.refresh()
			. = back.to_text(replace)
			value = .
		reverse()
			. = ""
			var/len = length(value)
			for(var/count = 0, count < len, count++)
				. += copytext(value,len-count,len+1-count)
			value = .